//
//  MyAnimationViewViewController.h
//  MyAnimationView
//
//  Created by 荻野 康之 on 10/02/09.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "MyAnimationView.h"

#define FRAME_RATIO 1.0/120.0;

@interface MyAnimationViewViewController : UIViewController {
	
	// アニメーション画像を設置するImageView用メモリ領域確保
	IBOutlet UIImageView *imageView;
	
	// フレームレート表示ラベル
	IBOutlet UILabel *debugMessage;
	
	// タイマー用メモリ領域確保
	NSTimer	 *updateTimer;

	// アニメーションを登録する配列用メモリ領域確保
	MyAnimationView *myAnime[9];
//	id myAnime;
}


// imagePathで指定した画像をposX,posYの位置に、width,heightの枠で表示
// totalFramesのコマ数を、メインのタイマーの 1/fpsRatio でアニメーションするMyAnimationViewインスタンスを作成するメソッド
// 与えたパラメータでMyAnimationViewインスタンスを作成し、そのポインタを返す
- (MyAnimationView*)makeAnimeViewWithParent:(UIImageView*)parentImageView
									   posX:(float)x posY:(float)y width:(float)w height:(float)h
								  imagePath:(NSString*)path fpsRatio:(int)fR totalFrames:(int)tF;

//どうしても引数でやりたい場合は、ポインタのポインタを使う
- (void)makeAnimeView:(MyAnimationView**)animeViewHandle parent:(UIImageView*)parentImageView
				 posX:(float)x posY:(float)y width:(float)w height:(float)h
			imagePath:(NSString*)path fpsRatio:(int)fR totalFrames:(int)tF;

// ダメな例
- (MyAnimationView*)pushAnimeView:(MyAnimationView*)animationView parent:(UIImageView*)parentImageView
							 posX:(float)x posY:(float)y width:(float)w height:(float)h
						imagePath:(NSString*)path fpsRatio:(int)fR totalFrames:(int)tF;

@end

