//
//  MyAnimationViewViewController.m
//  MyAnimationView
//
//  Created by 荻野 康之 on 10/02/09.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "MyAnimationViewViewController.h"

@implementation MyAnimationViewViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

- (void)startUpdateTimer:(NSTimeInterval)interval
{
	if(updateTimer)
		[updateTimer invalidate];
	
	updateTimer = [NSTimer scheduledTimerWithTimeInterval:interval
												   target:self 
												 selector:@selector(doUpdate:) 
												 userInfo:nil 
												  repeats:YES];
}

- (void)doUpdate:(NSTimer*)aTimer
{
	//printf("doUpdate.\n");
	
	// MyAnimationViewインスタンスの更新処理を呼び出す
	for(int i=0; i<9; i++) [myAnime[i] update];
}

// imagePathで指定した画像をposX,posYの位置に、width,heightの枠で表示
// totalFramesのコマ数を、メインのタイマーの 1/fpsRatio でアニメーションするMyAnimationViewインスタンスを作成するメソッド
- (MyAnimationView*)makeAnimeViewWithParent:(UIImageView*)parentImageView
									   posX:(float)x posY:(float)y width:(float)w height:(float)h
									   imagePath:(NSString*)path fpsRatio:(int)fR totalFrames:(int)tF
{
	MyAnimationView *animeView;
	
	printf("pushAnimeView.\n");
	
	// ビューの位置と大きさを決める構造体
	CGRect myAnimeRect = CGRectMake(x, y, w, h);
	
	// ビューの大きさと読み込む画像ファイルを指定して初期化
	animeView = [[[MyAnimationView alloc] initWithFrameImageName:myAnimeRect imagePath:path fpsRatio:fR totalFrames:tF] autorelease];
	
	// イメージビューにこのビューを追加
	[parentImageView addSubview:animeView];//subviewに加えられた時点でretainが一つかかる
	//subviewから外した時点で、retainが外れるので、autoreleaseされる
	
	return animeView;
}

//どうしても引数でやりたい場合は、ポインタのポインタを使う
- (void)makeAnimeView:(MyAnimationView**)animeViewHandle parent:(UIImageView*)parentImageView
				 posX:(float)x posY:(float)y width:(float)w height:(float)h
				 imagePath:(NSString*)path fpsRatio:(int)fR totalFrames:(int)tF
{	
	printf("pushAnimeView2.\n");
	
	// ビューの位置と大きさを決める構造体
	CGRect myAnimeRect = CGRectMake(x, y, w, h);
	
	// ビューの大きさと読み込む画像ファイルを指定して初期化
	*animeViewHandle = [[[MyAnimationView alloc] initWithFrameImageName:myAnimeRect imagePath:path fpsRatio:fR totalFrames:tF] autorelease];
	
	// イメージビューにこのビューを追加
	[parentImageView addSubview:*animeViewHandle];//subviewに加えられた時点でretainが一つかかる
	//subviewから外した時点で、retainが外れるので、autoreleaseされる
	
}

// ダメな例
- (MyAnimationView*)pushAnimeView:(MyAnimationView*)animationView parent:(UIImageView*)parentImageView
							 posX:(float)x posY:(float)y width:(float)w height:(float)h
						imagePath:(NSString*)path fpsRatio:(int)fR totalFrames:(int)tF
{
	printf("pushAnimeView.\n");
	
	// ビューの位置と大きさを決める構造体
	CGRect myAnimeRect = CGRectMake(x, y, w, h);
	
	// ビューの大きさと読み込む画像ファイルを指定して初期化
	animationView = [[MyAnimationView alloc] initWithFrameImageName:myAnimeRect imagePath:path fpsRatio:fR totalFrames:tF];
	
	// イメージビューにこのビューを追加
	[parentImageView addSubview:animationView];
	
	return animationView;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	
	printf("viewDidLoad\n");
	
    [super viewDidLoad];
	
	// アニメーション画像を取り付けたいimageView
	// そのimageView内での x, y座標と、サイズ
	// アニメーションに使用する画像と、タイマーの何分の１で動くか、コマ数はいくつか
	for(int i=0;i<8;i++)
	{
		myAnime[i] = [self makeAnimeViewWithParent:imageView
											  posX:40.0*i posY:0.0 width:40.0 height:140.0
										 imagePath:@"anime_sample.png" fpsRatio:i+1 totalFrames:20];
	}
	
	
	myAnime[8] = [self makeAnimeViewWithParent:imageView
										  posX:140.0 posY:160.0 width:40.0 height:140.0
									 imagePath:@"anime_sample.png" fpsRatio:4 totalFrames:20];
	
	
	
	// タイマーで更新間隔をセット
	[self startUpdateTimer:1.0/120.0];

	debugMessage.text = [NSString stringWithFormat:@"Timer at 120.0 fps"];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[super dealloc];
}

@end
