//
//  MyAnimationView.h
//  フレームアニメーションクラス
//

#import <UIKit/UIKit.h>
#import "MyImageView.h"

// 継承元をMyImageViewに変更
@interface MyAnimationView : MyImageView 
{
	int drawCount;		// 現在のテクスチャ位置を決める番号
	int totalFrames;	// フレーム総数
	int fpsRatio;		// フレームレート調整変数
	int fpsRatioCount;	// フレームレート調整のためのカウントに使う変数

	CGPoint rectPos;	// ビュー位置の構造体
	CGSize  rectSize;	// ビューサイズの構造体
}

// 外部でも使えるようにな宣言にしておく
-(id)initWithFrameImageName:(CGRect)rF imagePath:(NSString*)iP fpsRatio:(int)fR totalFrames:(int)tF;
-(void)update;


// プロパティの宣言
// 変数posを外部からでも読みだしのみ出来るようにする
@property (readonly) CGPoint rectPos;

@end
