//
//  MyAnimationView.m
//  フレームアニメーションクラス
//

#import "MyAnimationView.h"

@implementation MyAnimationView

@synthesize rectPos;


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
    }
    return self;
}

// イニシャライザ
- (id)initWithFrameImageName:(CGRect)rF imagePath:(NSString*)iP fpsRatio:(int)fR totalFrames:(int)tF
{
	// 親クラスの初期化処理が行われた場合、このクラスの変数を初期化
	if(self = [super initWithFrameImageName:rF path:iP])
	{
		// フレームレート制御用変数を初期化
		fpsRatioCount = 0;
		
		// テクスチャ番号を初期化
		drawCount = 0;
		
		// アニメーション設定
		fpsRatio	= fR;
		totalFrames = tF;
		
		// ビューの表示位置、サイズを初期化
		rectPos	 = CGPointMake(0,0);
		rectSize = CGSizeMake(rF.size.width,rF.size.height);
		
		// ビューの位置を移動させる
		// 変数transformは行列の要素を持った構造体
		self.transform = CGAffineTransformTranslate(self.transform, rectPos.x, rectPos.y);
		
		// 背景を透明化
		self.backgroundColor = [UIColor clearColor];
	}
	return self;
}


// 更新したい時に呼び出すメソッド（メインのタイマーから呼び出す）
-(void)update
{	
	if(fpsRatioCount == fpsRatio)
	{
		fpsRatioCount = 0;
		
		// テクスチャの描画位置を決める番号を増やす
		drawCount++;
		
		// テクスチャの描画位置が
		// totalFrames分動いたら最初に戻るようにする
		drawCount %= totalFrames;
		
		// テクスチャの描画する位置を移動する
		drawPoint.x = -rectSize.width * drawCount;
		
		// このビューを再描画する
		[self setNeedsDisplay];
	}
	fpsRatioCount++;
}

- (void)drawRect:(CGRect)rect 
{
	// ビューに画像を表示する
	// 親クラスのdrawRectを呼び出している
	[super drawRect:rect];
}


- (void)dealloc {
    [super dealloc];
}


@end
